<?php
/**
*	@file editor.php
*	@brief An administator view editor page.
*	A base of the game editor. Depending on selected tab, game administrators can change settings related to their games, edit or create cards etc.
*/ 
require_once(dirname(__FILE__) . '/admin_functions.php');

do_basic_operations();

// if user pressed submit button process forms
if (isset($_POST['import_csv_file']) || isset($_POST['create_new_card']) || isset($_POST['edit_card']) || isset($_POST['edit_cards']) || isset($_POST['delete_card']) || isset($_POST['change_image_folder']) || isset($_POST['change_slug']) || isset($_POST['change_password']) || isset($_POST['change_admins']) || isset($_POST['change_game_settings']) || isset($_POST['admin_editor_form_update_texts']) || isset($_POST['admin_editor_form_texts_add_translation']) || isset($_POST['admin_editor_form_texts_select_translation']) || isset($_POST['delete_game_modal_yes_button']) || isset($_POST['change_background_color']) || isset($_POST['change_text_color']) || isset($_POST['change_link_color']) || isset($_POST['change_link_hover_color']) || isset($_POST['change_button_color']) || isset($_POST['change_button_hover_color']) || isset($_POST['change_logo']) || isset($_POST['change_background_tile']) || isset($_POST['change_visible_stats'])) {
	process_admin_editor_forms();
}
if (isset($_SESSION['isLogged']) && isset($_SESSION['user']['user_id']) && isset($_SESSION['admin']['game']['game_id'])) {
		
	$db = DB::getInstance();
	$admins = $db->getAdminIDs($_SESSION['admin']['game']['game_id']);
	global $super_admin_id;
	// if user isn't admin of current game or superadmin redirect
	if (!in_array($_SESSION['user']['user_id'], $admins) && ($super_admin_id != $_SESSION['user']['user_id'])) {
		header('Location: index.php');
		die();
	}
} else {
	header('Location: index.php');
	die();
}

// Get db object and set game variable or get game from session array
$db = DB::getInstance();
$game_id = 0;
$game = array();
if (isset($_SESSION['admin']['game']['game_id'])) {
	$game_id = $_SESSION['admin']['game']['game_id'];
	$game = $_SESSION['admin']['game'];
}
print_admin_html_start('ADMIN_EDITOR_TITLE');
print_admin_header(); 
/** Contains every error if there are any. */
$editor_form_errors = array();

/** An array to hold errors in form if any. Defined in admin_editor_form_handling.php */
global $form_errors;

if (!empty($form_errors)) {
	$editor_form_errors = $form_errors;
}


/** Variable to define which tab is active. */
$active_tab = 'card_editor';

if (isset($_SESSION['admin']['tab']) && !empty($_SESSION['admin']['tab'])) {
	$active_tab = $_SESSION['admin']['tab'];
}
if (isset($_GET['tab'])) {
	$active_tab = $_GET['tab'];
}

/** Active tab is stored to session variable */
$_SESSION['admin']['tab'] = $active_tab;
?>
<div class="editor_wrapper">
	<div class="editor_tabs">
		<a href="editor.php?tab=card_editor"><span class="editor_tab trapezoid<?php if ($active_tab == 'card_editor') echo(" active"); ?>"><?php echo localize('ADMIN_EDITOR_CARD_TAB')?></span></a>
		<a href="editor.php?tab=profiles"><span class="editor_tab trapezoid<?php if ($active_tab == 'profiles') echo(" active"); ?>"><?php echo localize('ADMIN_EDITOR_PROFILES_TAB')?></span></a>
		<a href="editor.php?tab=settings"><span class="editor_tab trapezoid<?php if ($active_tab == 'settings') echo(" active"); ?>"><?php echo localize('ADMIN_EDITOR_SETTINGS_TAB')?></span></a>
		<a href="editor.php?tab=import-export"><span class="editor_tab trapezoid<?php if ($active_tab == 'import-export') echo(" active"); ?>"><?php echo localize('ADMIN_EDITOR_IMPORT-EXPORT_TAB')?></span></a>
	</div>
	<div class="editor_content">

<?php $show_user_settings = false;
		if (isset($_POST['notifications']['password_changed'])) {
			$show_user_settings = true;
		}
?>

<?php
if ($active_tab == 'card_editor') {
	include(dirname(__FILE__) . '/editor_tab_cards.php'); 
}
elseif ($active_tab == 'profiles') {
	include(dirname(__FILE__) . '/editor_tab_profiles.php'); 
}		
elseif ($active_tab == 'settings') {
	include(dirname(__FILE__) . '/editor_tab_settings.php'); 
}	
elseif ($active_tab == 'import-export') {
	include(dirname(__FILE__) . '/editor_tab_import-export.php'); 
}
?>
	</div><!-- .editor_content -->
	<?php print_admin_footer(); ?>
</div><!-- .editor_wrapper -->

<div class="jqmWindow" id="user_settings_modal">
	<a href="#" class="jqmClose" id="user_settings_modal_close"><?php echo localize('CLOSE'); ?></a>
	<h2><?php echo localize('ADMIN_EDITOR_USER_SETTINGS')?></h2>
<?php if (isset($_POST['notifications']['password_changed'])) :
			if ($_POST['notifications']['password_changed']) : ?>
	<p class="notification">
		<?php echo localize('ADMIN_EDITOR_NOTIFICATION_PASSWORD_CHANGED'); ?>
	</p>
<?php 	endif; ?>
<?php endif; ?>
	<form id="user_settings_form" class="admin_form small_input" method="post" action="">
		<label for="editor[settings][new_password]"><?php echo localize('ADMIN_EDITOR_CHANGE_PASSWORD')?></label><input class="" type="password" name="editor[settings][new_password]" id="editor[settings][new_password]" value="<?php if(isset($_POST['editor']['settings']['new_password'])) echo $_POST['editor']['settings']['new_password']; ?>" />
		<?php	if (isset($editor_form_errors['editor']['settings']['new_password'])) : ?>
		<p class="error"><?php echo $editor_form_errors['editor']['settings']['new_password']; ?></p>
		<?php endif; ?>
		<label for="editor[settings][new_password2]"><?php echo localize('ADMIN_EDITOR_CHANGE_PASSWORD2')?></label><input class="" type="password" name="editor[settings][new_password2]" id="editor[settings][new_password2]" value="<?php if(isset($_POST['editor']['settings']['new_password2'])) echo $_POST['editor']['settings']['new_password2']; ?>" />
		<?php	if (isset($editor_form_errors['editor']['settings']['new_password2'])) : ?>
		<p class="error"><?php echo $editor_form_errors['editor']['settings']['new_password2']; ?></p>
		<?php endif; ?>
		<label for="editor[settings][email]"><?php echo localize('APP_INDEX_EMAIL')?></label><input class="" type="text" name="editor[settings][email]" id="editor[settings][email]" value="<?php if(isset($_POST['editor']['settings']['email'])) { echo $_POST['editor']['settings']['email']; } elseif(isset($_SESSION['user']['email'])) { echo $_SESSION['user']['email'];} ?>" />
		<?php	if (isset($editor_form_errors['editor']['settings']['email'])) : ?>
		<p class="error"><?php echo $editor_form_errors['editor']['settings']['email']; ?></p>
		<?php endif; ?>
		<label for="editor[settings][current_password]"><?php echo localize('ADMIN_EDITOR_CURRENT_PASSWORD')?></label><input class="" type="password" name="editor[settings][current_password]" id="editor[settings][current_password]" value="<?php if(isset($_POST['editor']['settings']['current_password'])) echo $_POST['editor']['settings']['current_password']; ?>" />
		<?php	if (isset($editor_form_errors['editor']['settings']['current_password'])) : ?>
		<p class="error"><?php echo $editor_form_errors['editor']['settings']['current_password']; ?></p>
		<?php endif; ?>
		<hr />
		<input class="" type="submit" class="" id="change_password" name="change_password" value="<?php echo localize('SAVE')?>" />
	</form>
</div>

<script type="text/JavaScript">
$(document).ready(function() {
	// Show user settings popup when needed
<?php if ($show_user_settings) : ?>
	$('#user_settings_button').click();
<?php endif; ?>
});
</script>

<?php echo print_html_end(); ?>