/* JavaScript for GAL2 application pages */

// Gets query parameter from url
// Taken from: http://stackoverflow.com/questions/901115/how-can-i-get-query-string-values
function getParameterByName(name) {
  name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
  var regexS = "[\\?&]" + name + "=([^&#]*)";
  var regex = new RegExp(regexS);
  var results = regex.exec(window.location.search);
  if(results == null)
    return "";
  else
    return decodeURIComponent(results[1].replace(/\+/g, " "));
}

// Gets game slug from url
function getGameSlug() {
	
	var url = document.URL;

	if (!window.modRewrite) {
		return getParameterByName('game_slug');
	}
	url = url.replace(window.baseurl + 'game/', '');
	var pos = url.indexOf('/');
	var slug = url.substring(0, pos);
	return slug;
}

/* Global variables: */
//Global current card info so that previous card choices can be set
window.globalCurrentCard;
// Global variable that tells should back button be enabled or not
window.globalBackEnabled = false;

$(document).ready(function() {
	
	/* Hide elements */
	$('#app_index_open_panel, #app_index_login_panel, #app_index_register_panel, #app_index_continue_panel').hide();
	
	/* Handlers for common pop ups*/
	
	$('#user_settings_modal').jqm({overlay: 50, trigger: false,
		onHide: function(h) { 
			h.o.remove(); // remove overlay
			h.w.fadeOut(300); // hide window
		}
	})
    .jqmAddTrigger($('#user_settings_button'))
    .jqmAddClose($('#user_settings_modal_close'));
	
	// Leaving page dialog
	$('#link_profile_modal').jqm({overlay: 50, trigger: false,
		onHide: function(h) { 
			h.o.remove(); // remove overlay
			h.w.fadeOut(300); // hide window
		}
	})
    .jqmAddTrigger($('#show_link_profile_modal'))
    .jqmAddClose($('#link_profile_modal_close1'))
    .jqmAddClose($('#link_profile_modal_close2'));
	
	$('#link_profile_modal_register').click( function() {
		window.showAddAccountPopupOnLeave = false;
		var slug = getGameSlug();
		if (window.modRewrite) {
			window.location = window.baseurl + "game/" + slug + "?showpanel=app_index_register";
		}
		else {
			window.location = window.baseurl + "app/index.php?game_slug=" + slug + "&showpanel=app_index_register";
		}
	});
	
	$('#link_profile_modal_close2').click( function() {
		window.showAddAccountPopupOnLeave = false;
		var slug = getGameSlug();
		
		if (window.modRewrite) {
			window.location = window.baseurl + "general/logout.php?game_slug=" + slug;
		}
		else {
			window.location = window.baseurl + "general/logout.php?game_slug=" + slug;
		}
	});
	
	$('#session_expired_modal').jqm({overlay: 50, trigger: false,
		onHide: function(h) { 
			h.o.remove(); // remove overlay
			h.w.fadeOut(300); // hide window
		}
	})
    .jqmAddTrigger($('#show_session_expired'))
    .jqmAddClose($('#session_expired_close'));
	
	$('#show_link_profile_modal, #show_session_expired').hide();
	
	/* Handlers for app index.php */
	$('#app_index_continue').click(function() {
		$('#app_index_continue_panel').show();
		$('#app_index_start_new_panel').hide();
		$('#app_index_open_panel').hide();
		$('#app_index_login_panel').hide();
		$('#app_index_register_panel').hide();
	});
	$('#app_index_start_new').click(function() {
		$('#app_index_start_new_panel').show();
		$('#app_index_continue_panel').hide();
		$('#app_index_open_panel').hide();
		$('#app_index_login_panel').hide();
		$('#app_index_register_panel').hide();
	});
	$('#app_index_open').click(function() {
		$('#app_index_open_panel').show();
		$('#app_index_start_new_panel').hide();
		$('#app_index_continue_panel').hide();
		$('#app_index_login_panel').hide();
		$('#app_index_register_panel').hide();
	});
	$('#app_index_login').click(function() {
		$('#app_index_login_panel').show();
		$('#app_index_open_panel').hide();
		$('#app_index_start_new_panel').hide();
		$('#app_index_continue_panel').hide();
		$('#app_index_register_panel').hide();
	});
	$('#app_index_register').click(function() {
		$('#app_index_register_panel').show();
		$('#app_index_login_panel').hide();
		$('#app_index_open_panel').hide();
		$('#app_index_start_new_panel').hide();
		$('#app_index_continue_panel').hide();
	});
	
	/* Handlers for simulation.php */
	$('#simulation_prev_card_panel').hide();
	$('#simulation_next').hide();
	$('.expert_advice').hide();
	$(".simulation_result_heading").hide();
	
	// Hide elements
	$("#simulation_current_result_loading, #simulation_current_result_content").hide();
	$("#simulation_prev_result_loading, #simulation_prev_result_content").hide();
	
	// If no image src then hide image
	var image_src1 = $('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').attr('src');
	var image_src2 = $('#simulation_prev_card_panel > .panel_content > #simulation_card_image > img').attr('src');
	if (image_src1 != '') {
		$('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').show();
		$('#simulation_current_card_panel > .panel_content > #simulation_card_image').show();
	}
	else {
		$('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').hide();
		$('#simulation_current_card_panel > .panel_content > #simulation_card_image').hide();
	}
	if (image_src2 != '') {
		$('#simulation_prev_card_panel > .panel_content > #simulation_card_image > img').show();
		$('#simulation_prev_card_panel > .panel_content > #simulation_card_image').show();
	}
	else {
		$('#simulation_prev_card_panel > .panel_content > #simulation_card_image > img').hide();
		$('#simulation_prev_card_panel > .panel_content > #simulation_card_image').hide();
	}
	
	// User selects a choice from the current card
	$(document).on('click', '.select_current', function(e) {
		e.preventDefault();
		$(this).addClass('simulation_selected_button');
		var checked_id = $(this).attr('id').split("simulation_current_choices_")[1];
		
		// Hide other choices
		$("#simulation_card_current_choices > button[name=simulation_current_choices]").each( function() {
			if ($(this).attr('id').split("simulation_current_choices_")[1] != checked_id) {
				$(this).hide(200);
			}
			else {
				$(this).attr('disabled', 'disabled');
			}
		});
		// TODO: Check if result should show loading image while result is fetched
		$("#simulation_current_result_loading").show();
		//$("#simulation_current_result_content").hide();
		
		// Hide stuff related to previous phase
		$("#simulation_current_card_panel > .panel_content > #simulation_card_name").hide(200);
		$("#simulation_current_card_panel > .panel_content > #simulation_card_description").hide(200);
		$("#simulation_current_card_panel > .panel_content > .selection_text").hide(200);
		$("#simulation_card_current_expert_advice").hide(200);
		$("#simulation_select").hide(200);
		$(".simulation_prev").hide(200);
		
		$.post(window.baseurl + "general/ajax.php", { action: 'save_choice_and_give_result', choice_id: checked_id }, "json").done(
				function(result) {
					
					// Check if session has expired and redirect
					if (result.session_expired != undefined && result.session_expired) {
						
						window.showAddAccountPopupOnLeave = false;
						var slug = getGameSlug();
						
						if (window.modRewrite) {
							window.location = window.baseurl + "game/" + slug;
						}
						else {
							window.location = window.baseurl + "app/index.php?game_slug=" + slug;
						}
					}
					var result_message = '';
					if (result.result_text) {
						result_message = result.result_text;
					}
					else {
						result_message = result.default_text;
					}
					// Replace stat tags from result
					var profile = $('#simulation_debug_player_profile').val();
					$.get(window.baseurl + "general/ajax.php", { action: 'replace_stat_tags', profile_id: profile, text: result_message }, "json").done(
							function(result) {
								$('#simulation_current_result_content > #simulation_result_description').html(result.modified_text); //.text(result.modified_text);
								$("#simulation_current_result_loading").hide();
								$("#simulation_current_result_content").show(200);
							}
					);
					
					// Get player stats
					//var profile = $('#simulation_debug_player_profile').val();
					$.get(window.baseurl + "general/ajax.php", { action: 'print_player_stats', profile_id: profile, header: true }, "html").done(
							function(stats) {
								$('.hidden_header_left_column').empty();
								$('.hidden_header_left_column').append(stats);
							}
					);
					
					//$('#simulation_current_result_content > #simulation_result_description').text(result_message);
					//$("#simulation_current_result_loading").hide();
					//$("#simulation_current_result_content").show(200);
				}
		);
	});
	
	// User selects a choice from the previous card
	$(document).on( 'click', '.select_prev', function(e) {
		e.preventDefault();
		$(this).addClass('simulation_selected_button');
		var checked_id = $(this).attr('id').split("simulation_prev_choices_")[1];
		// Hide other choices
		$("#simulation_card_prev_choices > button[name=simulation_prev_choices]").each( function() {
			if ($(this).attr('id').split("simulation_prev_choices_")[1] != checked_id) {
				$(this).hide(200);
			}
			else {
				$(this).attr('disabled', 'disabled');
			}
		});
		// TODO: Check if result should show loading image while result is fetched
		$("#simulation_prev_result_loading").show();
		//$("#simulation_prev_result_content").hide();
		
		// Hide stuff related to previous phase
		$("#simulation_prev_card_panel > .panel_content > #simulation_card_name").hide(200);
		$("#simulation_prev_card_panel > .panel_content > #simulation_card_description").hide(200);
		$("#simulation_prev_card_panel > .panel_content > .selection_text").hide(200);
		$("#simulation_card_prev_expert_advice").hide(200);
		$("#simulation_select_prev").hide(200);
		$(".simulation_prev_prev").hide(200);
		
		$.post(window.baseurl + "general/ajax.php", { action: 'save_choice_and_give_result', choice_id: checked_id }, "json").done(
				function(result) {
					
					// Check if session has expired and redirect
					if (result.session_expired != undefined && result.session_expired) {

						window.showAddAccountPopupOnLeave = false;
						var slug = getGameSlug();
						
						if (window.modRewrite) {
							window.location = window.baseurl + 'game/' + slug;
						}
						else {
							window.location = window.baseurl + "app/index.php?game_slug=" + slug;
						}
					}
					var result_message = '';
					if (result.result_text) {
						result_message = result.result_text;
					}
					else {
						result_message = result.default_text;
					}
					// Replace stat tags from result
					var profile = $('#simulation_debug_player_profile').val();
					$.get(window.baseurl + "general/ajax.php", { action: 'replace_stat_tags', profile_id: profile, text: result_message }, "json").done(
							function(result) {
								$('#simulation_prev_result_content > #simulation_result_description').html(result.modified_text); //.text(result.modified_text);
								$("#simulation_prev_result_loading").hide();
								$("#simulation_prev_result_content").show(200);
							}
					);
					// Get player stats
					//var profile = $('#simulation_debug_player_profile').val();
					$.get(window.baseurl + "general/ajax.php", { action: 'print_player_stats', profile_id: profile, header: true }, "html").done(
							function(stats) {
								$('.hidden_header_left_column').empty();
								$('.hidden_header_left_column').append(stats);
							}
					);
					
					//$('#simulation_prev_result_content > #simulation_result_description').text(result_message);
					//$("#simulation_prev_result_loading").hide();
					//$("#simulation_prev_result_content").show(200);
				}
		);
	});
	
	// User clicked continue button of current card
	$(document).on( 'click', '#simulation_continue_current', function() {
		
		$('#simulation_next_card_loading').show();
		
		// This is necessary only if player has received any card via ajax
		if (window.globalCurrentCard != undefined) {
			
			// Switch previous card values to current card
			var card_name = $('#simulation_current_card_panel > .panel_content > #simulation_card_name').html(); //.text();
			$('#simulation_prev_card_panel > .panel_content > #simulation_card_name').html(card_name); //.text(card_name);
			
			var image_src = $('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').attr('src');
			$('#simulation_prev_card_panel > .panel_content > #simulation_card_image > img').attr('src', image_src);
			
			var description = $('#simulation_current_card_panel > .panel_content > #simulation_card_description').html(); //.text();
			$('#simulation_prev_card_panel > .panel_content > #simulation_card_description').html(description); //.text(description);
			
			var expert_advice = $('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice > .expert_advice').html();//p.expert_advice').text();
			$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice > .expert_advice').html(expert_advice); //p.expert_advice').text(expert_advice);
			
			if (expert_advice == undefined || !expert_advice.length) {
				$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice').hide();
			}
			else {
				$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice').show();
			}
			
			var card_id = $('#simulation_current_card_panel > .panel_content > #current_card_id').val();
			$('#simulation_prev_card_panel > .panel_content > #prev_card_id').val(card_id);
			
			$('#simulation_card_prev_choices').empty();
			
			if (window.globalCurrentCard.choices == undefined) {
				window.globalCurrentCard.choices = [];
			}
				
			// Get choices from db because different html element ids between current and previous card
			$.get(window.baseurl + "general/ajax.php", { action: 'print_card_choices', choices: window.globalCurrentCard.choices, position: 'prev' }, "html").done(
					function(choices) {
						
						// TODO: Make a function of this!
						// Check if session has expired and redirect
						if (choices.session_expired != undefined && choices.session_expired) {
							window.showAddAccountPopupOnLeave = false;
							var slug = getGameSlug();
							
							if (window.modRewrite) {
								window.location = window.baseurl + 'game/' + slug;
							}
							else {
								window.location = window.baseurl + "app/index.php?game_slug=" + slug;
							}
						}
						if (choices != undefined) {
							$('#simulation_card_prev_choices').append(choices);
						}
					}
			);
		}
		
		//  Update current card values to values from new card
		$.get(window.baseurl + "general/ajax.php", { action: 'play_card' }, "json").done(
				function(card) {
					
					// Check if session has expired and redirect
					if (card.session_expired != undefined && card.session_expired) {
						window.showAddAccountPopupOnLeave = false;
						var slug = getGameSlug();

						if (window.modRewrite) {
							window.location = window.baseurl + 'game/' + slug;
						}
						else {
							window.location = window.baseurl + "app/index.php?game_slug=" + slug;
						}
					}
					// Update global variable
					window.globalCurrentCard = card;
					window.globalBackEnabled = card.back_enabled;
					
					// TODO: This can be done in function
					// Check if game ended and redirect
					if (card.game_ended != undefined && card.game_ended) {
						window.showAddAccountPopupOnLeave = false;
						var slug = getGameSlug();
						
						if (window.modRewrite) {
							window.location = window.baseurl + 'game/' + slug + '/end';
						}
						else {
							window.location = window.baseurl + "app/end.php?game_slug=" + slug;
						}
					}
					
					// Set timeout so that current card doesn't update during slide
					window.setTimeout(function() {	
					
						
					var card_name = '';
					if (card.card_name) {
						card_name = card.card_name;
					}
					else {
						card_name = card.default_name;
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_name').html(card_name); //.text(card_name);
					
					var image_src = '';
					if (card.imageURL) {
						image_src = card.imageURL;
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').attr('src', image_src);
					if (image_src != '') {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').show();
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image').show();
					}
					else {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').hide();
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image').hide();
					}
					
					var description = '';
					if (card.description) {
						description = card.description;
					}
					else {
						description = card.default_description;
					}
					// Replace stat tags from description
					var profile = $('#simulation_debug_player_profile').val();
					$.get(window.baseurl + "general/ajax.php", { action: 'replace_stat_tags', profile_id: profile, text: description }, "json").done(
							function(result) {
								$('#simulation_current_card_panel > .panel_content > #simulation_card_description').html(result.modified_text); //.text(result.modified_text);
							}
					);
					//$('#simulation_current_card_panel > .panel_content > #simulation_card_description').text(description);

					var expert_advice = '';
					if (card.expert_advice) {
						expert_advice = card.expert_advice;
					}
					else {
						expert_advice = card.default_expert_advice;
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice > .expert_advice').html(expert_advice);//p.expert_advice').text(expert_advice);
					if (!expert_advice.length) {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice').hide();
					}
					else {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice').show();
					}
					$('#simulation_current_card_panel > .panel_content > #current_card_id').val(card.card_id);

					$('#simulation_card_current_choices').empty();
					
					if (card.choices == undefined) {
						card.choices = [];
					}
					
					$.get(window.baseurl + "general/ajax.php", { action: 'print_card_choices', choices: card.choices, position: 'current' }, "html").done(
							function(choices) {
								
								// Check if session has expired and redirect
								if (choices.session_expired != undefined && choices.session_expired) {
									//console.log("session expired");
									window.showAddAccountPopupOnLeave = false;
									//var slug = getParameterByName('game_slug');
									var slug = getGameSlug();
									//window.location = "index.php?game_slug=" + slug;
									
									if (window.modRewrite) {
										window.location = window.baseurl + 'game/' + slug;
									}
									else {
										window.location = window.baseurl + "app/index.php?game_slug=" + slug;
									}
								}
								
								if (choices != undefined) {
									// Replace stat tags from choices
									var profile = $('#simulation_debug_player_profile').val();
									$.get(window.baseurl + "general/ajax.php", { action: 'replace_stat_tags', profile_id: profile, text: choices }, "json").done(
											function(result) {
												$('#simulation_card_current_choices').append(result.modified_text);
												$('#simulation_next_card_loading').hide(200);
												$('#simulation_next').click();
											}
									);
								}
								// Check if sudden scenario
								/*if (!$('#simulation_card_current_choices').children().length) {
									//$('#simulation_current_result_content').show();
									$('.selection_text').hide();
									$('#continue_simulation_current_button').show();
								}
								else {
									//$('#simulation_current_result_content').hide();
									$('.selection_text').show();
									$('#continue_simulation_current_button').hide();
								}*/
								// edelliset oli jo kommentoitu pois ----------------------------------------------------------------
								//$('#simulation_next_card_loading').hide(200);
								//$('#simulation_next').click();
							}
					);
					}, 1000); // setTimeout
				}
		);
		//TODO: simulation_continue_current 
		// This have to be done because of proper scrolling effect from left to right
		//$('.panel_wrapper').scrollTo('#simulation_loading_panel', 0);
		var loading_panel = $('#simulation_loading_panel');
		var current_card_panel = $('#simulation_current_card_panel');
		$('#simulation_loading_panel').hide();
		$('#simulation_current_card_panel').hide();
		$('#simulation_loading_panel').remove();
		$('#panel_mask_app').append(current_card_panel);
		$('#panel_mask_app').append(loading_panel);
		$('#simulation_prev_card_panel').show();
		$('#simulation_loading_panel').show();
		$('#simulation_current_card_panel').show();
		$('.panel_wrapper').scrollTo('#simulation_current_card_panel', 0);
	});
	
	$(document).on( 'click', '#simulation_continue_prev', function() {
		
		//console.log("simulation_continue_prev");
		$('#simulation_next_card_loading').show();
		// This panel becomes the previous so only showing hidden choices is necessary
		// before updating the current card
		/*$("#simulation_card_prev_choices > button[name=simulation_prev_choices]").each( function() {
			$(this).show();
		});*/
		
		//  Update current card values to values from new card
		$.get(window.baseurl + "general/ajax.php", { action: 'play_card' }, "json").done(
				function(card) {
					
					// Check if session has expired and redirect
					if (card.session_expired != undefined && card.session_expired) {
						//console.log("session expired");
						window.showAddAccountPopupOnLeave = false;
						//var slug = getParameterByName('game_slug');
						var slug = getGameSlug();
						//window.location = "index.php?game_slug=" + slug;
						
						if (window.modRewrite) {
							window.location = window.baseurl + 'game/' + slug;
						}
						else {
							window.location = window.baseurl + "app/index.php?game_slug=" + slug;
						}
					}
					
					// Update global variable
					window.globalCurrentCard = card;
					window.globalBackEnabled = card.back_enabled;
					
					// Check if game ended and redirect
					if (card.game_ended != undefined && card.game_ended) {
						//console.log("game ended");
						window.showAddAccountPopupOnLeave = false;
						//var slug = getParameterByName('game_slug');
						var slug = getGameSlug();
						//window.location = "end.php?game_slug=" + slug;
						
						if (window.modRewrite) {
							window.location = window.baseurl + 'game/' + slug + '/end';
						}
						else {
							window.location = window.baseurl + "app/end.php?game_slug=" + slug;
						}
					}
					
					// So that current card doesn't update during slide
					window.setTimeout(function() {	
					
						
						
					var card_name = '';
					if (card.card_name) {
						card_name = card.card_name;
					}
					else {
						card_name = card.default_name;
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_name').html(card_name); //.text(card_name);
					
					var image_src = '';
					if (card.imageURL) {
						image_src = card.imageURL;
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').attr('src', image_src);
					if (image_src != '') {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').show();
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image').show();
					}
					else {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').hide();
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image').hide();
					}
					
					var description = '';
					if (card.description) {
						description = card.description;
					}
					else {
						description = card.default_description;
					}
					// Replace stat tags from description
					var profile = $('#simulation_debug_player_profile').val();
					$.get(window.baseurl + "general/ajax.php", { action: 'replace_stat_tags', profile_id: profile, text: description }, "json").done(
							function(result) {
								$('#simulation_current_card_panel > .panel_content > #simulation_card_description').html(result.modified_text); //.text(result.modified_text);
							}
					);
					//$('#simulation_current_card_panel > .panel_content > #simulation_card_description').text(description);

					var expert_advice = '';
					if (card.expert_advice) {
						expert_advice = card.expert_advice;
					}
					else {
						expert_advice = card.default_expert_advice;
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice > .expert_advice').html(expert_advice); //p.expert_advice').text(expert_advice);
					if (!expert_advice.length) {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice').hide();
					}
					else {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice').show();
					}
					$('#simulation_current_card_panel > .panel_content > #current_card_id').val(card.card_id);

					$('#simulation_card_current_choices').empty();
					if (card.choices == undefined) {
						card.choices = [];
					}
					$.get(window.baseurl + "general/ajax.php", { action: 'print_card_choices', choices: card.choices, position: 'current' }, "html").done(
							function(choices) {
								
								// Check if session has expired and redirect
								if (choices.session_expired != undefined && choices.session_expired) {
									//console.log("session expired");
									window.showAddAccountPopupOnLeave = false;
									//var slug = getParameterByName('game_slug');
									var slug = getGameSlug();
									//window.location = "index.php?game_slug=" + slug;
									if (window.modRewrite) {
										window.location = window.baseurl + 'game/' + slug;
									}
									else {
										window.location = window.baseurl + "app/index.php?game_slug=" + slug;
									}
								}
								
								if (choices != undefined) {
									// Replace stat tags from choices
									var profile = $('#simulation_debug_player_profile').val();
									$.get(window.baseurl + "general/ajax.php", { action: 'replace_stat_tags', profile_id: profile, text: choices }, "json").done(
											function(result) {
												$('#simulation_card_current_choices').append(result.modified_text);
												$('#simulation_next_card_loading').hide(200);
												$('#simulation_next').click();
											}
									);
									//$('#simulation_card_current_choices').append(choices);
								}
									// Check if ending or sudden scenario
								/*if (!$('#simulation_card_current_choices').children().length) {
									$('#simulation_current_result_content').show();
									$('.selection_text').hide();
								}
								else {
									$('#simulation_current_result_content').hide();
									$('.selection_text').show();
								}*/
								// edelliset oli kommentoitu jo pois ------------------------------------
								//$('#simulation_next_card_loading').hide(200);
								//$('#simulation_next').click();
							}
					);
					}, 1000); // setTimeout
				}
		);
		//TODO: simulation_continue_prev 
		// This have to be done because of proper scrolling effect from left to right
		//$('.panel_wrapper').scrollTo('#simulation_loading_panel', 0);
		var loading_panel = $('#simulation_loading_panel');
		var prev_card_panel = $('#simulation_prev_card_panel');
		$('#simulation_current_card_panel').hide();
		$('#simulation_loading_panel').hide();
		$('#simulation_prev_card_panel').hide();
		$('#simulation_loading_panel').remove();
		$('#simulation_prev_card_panel').remove();
		$('#panel_mask_app').append(prev_card_panel);
		$('#panel_mask_app').append(loading_panel);
		$('#simulation_prev_card_panel').show();
		$('#simulation_loading_panel').show();
		$('#simulation_current_card_panel').show();
		$('.panel_wrapper').scrollTo('#simulation_prev_card_panel', 0);
	});
	
	$(document).on( 'click', '#simulation_next', function(e) {
		//console.log("simulation_next");
		// Reset choices
		$("#simulation_card_prev_choices > input:radio[name=simulation_prev_choices]:checked").removeAttr('checked');
		$("#simulation_card_current_choices > input:radio[name=simulation_current_choices]:checked").removeAttr('checked');
		$("#simulation_card_prev_choices > input:radio[name=simulation_prev_choices]:disabled").removeAttr('disabled');
		$("#simulation_card_current_choices > input:radio[name=simulation_current_choices]:disabled").removeAttr('disabled');
		
		$("#simulation_current_result_loading").hide();
		$("#simulation_current_result_content").hide();
		$("#simulation_prev_result_loading").hide();
		$("#simulation_prev_result_content").hide();
		
		// Reveal stuff hided before
		$("#simulation_current_card_panel > .panel_content > #simulation_card_name").show();
		$("#simulation_prev_card_panel > .panel_content > #simulation_card_name").show();
		$("#simulation_current_card_panel > .panel_content > #simulation_card_description").show();
		$("#simulation_prev_card_panel > .panel_content > #simulation_card_description").show();
		
		if ($('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice > .expert_advice').html()) { //p.expert_advice').text()) {
			$("#simulation_card_current_expert_advice").show();
		}
		else {
			$("#simulation_card_current_expert_advice").hide();
		}
		//$("#simulation_card_current_expert_advice").show();
		if ($('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice > .expert_advice').html()) {//p.expert_advice').text()) {
			$("#simulation_card_prev_expert_advice").show();
		}
		else {
			$("#simulation_card_prev_expert_advice").hide();
		}
		//$("#simulation_card_prev_expert_advice").show();
		$('.expert_advice').hide();
		$("#simulation_select").show();
		$(".selection_text").show(); // both
		$(".simulation_result_heading").hide();
		$("#simulation_select_prev").show();
		
		// Check if there are no choices
		if (!$('#simulation_card_current_choices').children().length) {
			$('#simulation_current_card_panel > .panel_content > .selection_text').hide();
			$('#continue_simulation_current_button').show();
			
			/*$.post("../general/ajax.php", { action: 'save_choice_and_give_result', choice_id: 0 }, "json").done(
					function(result) {
						
						var result_message = '';
						if (result.result_text != undefined) {
							result_message = result.result_text;
						}
						else {
							result_message = result.default_text;
						}
						// So that current card doesn't update during slide
						//window.setTimeout(function() {	
						// TODO: remove this Debug
						var profile = $('#simulation_debug_player_profile').val();
						$.get("../general/ajax.php", { action: 'print_player_stats', profile_id: profile }, "html").done(
								function(stats) {
									$('#debug > #player_stats').text(stats);
									
								}
						);
						
						$('#simulation_current_result_content > #simulation_result_description').text(result_message);
						
						if ($(this).attr('id') == "continue_simulation_current_button") {
							$("#simulation_continue_current").click();
						}
						else {
							$("#simulation_continue_prev").click();
						}
					//}, 1000);  // setTimeout
					}
			);*/
		}
		else {
			//$('#simulation_current_result_content').hide();
			//$('.selection_text').show();
			$('#continue_simulation_current_button').hide();
		}
		
		// Enable back-buttons
		if (window.globalBackEnabled) {
			$('.simulation_prev').show();
		}
		
		
		//$('#simulation_result_panel > .panel_content > #simulation_card_choice').empty();
		//$("#simulation_card_current_choices").clone().appendTo($('#simulation_result_panel > .panel_content > #simulation_card_choice'));
		
		//$('#simulation_prev_choices').val('1');
		//$('#simulation_current_choices').val('1');
		
		//TODO: simulation_next 
		//$('.panel_wrapper').scrollTo('#simulation_current_card_panel', 0);
		var current_card_panel = $('#simulation_current_card_panel');
		$('#simulation_current_card_panel').hide();
		$('#simulation_current_card_panel').remove();
		$('#panel_mask_app').append(current_card_panel);
		//$('#simulation_current_card_panel').append(current_card_content);
		$('#simulation_prev_card_panel').show();
		$('#simulation_loading_panel').show();
		$('#simulation_current_card_panel').show();
		$('#panel_mask_app').append(current_card_panel);
		$('.panel_wrapper').scrollTo('#simulation_loading_panel', 0);
	});
	
	// Back button action on current card panel
	$(document).on( 'click', '.simulation_prev', function(e) {
		//console.log("simulation_prev");
		$('#simulation_next_card_loading').show();
		// Show choices
		$("#simulation_card_prev_choices > button[name=simulation_prev_choices]").each( function() {
			$(this).show();
		});
		$("#simulation_card_prev_choices > button[name=simulation_prev_choices]:disabled").removeAttr('disabled');
		
		// Check if there are no choices
		if (!$('#simulation_card_prev_choices').children().length) {
			$('#simulation_prev_card_panel > .panel_content > .selection_text').hide();
			$('#continue_simulation_prev_button').show();
		}
		else {
			//$('#simulation_current_result_content').hide();
			$('#simulation_prev_card_panel > .panel_content > .selection_text').show();
			$('#continue_simulation_prev_button').hide();
		}
		
		var image_src = $('#simulation_prev_card_panel > .panel_content > #simulation_card_image > img').attr('src');
		if (image_src == undefined) {
			image_src = '';
		}
		if (image_src != '') {
			$('#simulation_prev_card_panel > .panel_content > #simulation_card_image > img').show();
			$('#simulation_prev_card_panel > .panel_content > #simulation_card_image').show();
		}
		else {
			$('#simulation_prev_card_panel > .panel_content > #simulation_card_image > img').hide();
			$('#simulation_prev_card_panel > .panel_content > #simulation_card_image').hide();
		}
		
		var expert_advice = $('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice > .expert_advice').html();//p.expert_advice').text();
		if (expert_advice == undefined) {
			expert_advice = '';
		}
		//console.log("expert_advice: " + expert_advice);
		if (expert_advice.length > 0) {
			$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice').show();
		}
		else {
			$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice').hide();
		}
		
		$.post(window.baseurl + "general/ajax.php", { action: 'previous_card' }, "json").done(
				function(cards) {
					
					// Check if session has expired and redirect
					if (cards.session_expired != undefined && cards.session_expired) {
						//console.log("session expired");
						window.showAddAccountPopupOnLeave = false;
						//var slug = getParameterByName('game_slug');
						var slug = getGameSlug();
						//window.location = "index.php?game_slug=" + slug;
						
						if (window.modRewrite) {
							window.location = window.baseurl + 'game/' + slug;
						}
						else {
							window.location = window.baseurl + "app/index.php?game_slug=" + slug;
						}
					}
					
					// update global current card
					window.globalCurrentCard = cards.current;
					window.globalBackEnabled = cards.back_enabled;
					
					// So that current card doesn't update during slide
					window.setTimeout(function() {
						
						// If next card doesn't exist
						if (cards.previous == undefined) {
							window.globalBackEnabled = false;
						}
						
						// Enable back-buttons
						if (window.globalBackEnabled) {
							$('.simulation_prev_prev').show();
						}
						else {
							$('.simulation_prev_prev').hide();
						}
						
						// Check if ending or sudden scenario
						/*if (!$('#simulation_card_prev_choices').children().length) {
							$('#simulation_prev_result_content').show();
							$('.selection_text').hide();
						}
						else {
							$('#simulation_prev_result_content').hide();
							$('.selection_text').show();
						}*/
					/*var card_name1 = '';
					if (cards.current.card_name) {
						card_name1 = cards.current.card_name;
					}
					else {
						card_name1 = cards.current.default_name;
					}
					var card_name2 = '';
					if (cards.previous.card_name) {
						card_name2 = cards.previous.card_name;
					}
					else {
						card_name2 = cards.previous.default_name;
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_name').text(card_name1);
					$('#simulation_prev_card_panel > .panel_content > #simulation_card_name').text(card_name2);

					var description1 = '';
					if (cards.current.description) {
						description1 = cards.current.description;
					}
					else {
						description1 = cards.current.default_description;
					}
					var description2 = '';
					if (cards.previous.description) {
						description2 = cards.previous.description;
					}
					else {
						description2 = cards.previous.default_description;
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_description').text(description1);
					$('#simulation_prev_card_panel > .panel_content > #simulation_card_description').text(description2);

					var expert_advice1 = '';
					if (cards.current.expert_advice) {
						expert_advice1 = cards.current.expert_advice;
					}
					else {
						expert_advice1 = cards.current.default_expert_advice;
					}
					var expert_advice2 = '';
					if (cards.previous.expert_advice) {
						expert_advice2 = cards.previous.expert_advice;
					}
					else {
						expert_advice2 = cards.previous.default_expert_advice;
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice > p.expert_advice').text(expert_advice1);
					if (!expert_advice1.length) {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice').hide();
					}
					else {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice').show();
					}
					$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice > p.expert_advice').text(expert_advice2);
					if (!expert_advice2.length) {
						$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice').hide();
					}
					else {
						$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice').show();
					}
					$('#simulation_current_card_panel > .panel_content > #current_card_id').val(cards.current.card_id);
					$('#simulation_prev_card_panel > .panel_content > #prev_card_id').val(cards.previous.card_id);
					$('#simulation_card_current_choices').empty();
					$('#simulation_card_prev_choices').empty();
					
					$.get("../general/ajax.php", { action: 'print_card_choices', choices: cards.current.choices, position: 'current' }, "html").done(
							function(choices) {
								
								$('#simulation_card_current_choices').append(choices);
								//$('#simulation_next_card_loading').hide(200);
								//$('#simulation_next').click();
							}
					);
					$.get("../general/ajax.php", { action: 'print_card_choices', choices: cards.previous.choices, position: 'prev' }, "html").done(
							function(choices) {
								
								$('#simulation_card_prev_choices').append(choices);
								//$('#simulation_next_card_loading').hide(200);
								//$('#simulation_next').click();
							}
					);
					*/
						// Replace stat tags in description
						var description = $('#simulation_prev_card_panel > .panel_content > #simulation_card_description').html(); //.text();
						var profile = $('#simulation_debug_player_profile').val();
						$.get(window.baseurl + "general/ajax.php", { action: 'replace_stat_tags', profile_id: profile, text: description }, "json").done(
								function(result) {
									$('#simulation_prev_card_panel > .panel_content > #simulation_card_description').html(result.modified_text); //.text(result.modified_text);
									
									// Replace stat tags in choices
									var choices = $('#simulation_card_prev_choices').html();
									var profile = $('#simulation_debug_player_profile').val();
									$.get(window.baseurl + "general/ajax.php", { action: 'replace_stat_tags', profile_id: profile, text: choices }, "json").done(
											function(result2) {
												$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_choices').html(result2.modified_text);
												$('.panel_wrapper').scrollTo('#simulation_prev_card_panel', 600);
												$('#simulation_next_card_loading').hide(200);
											}
									);
									//$('.panel_wrapper').scrollTo('#simulation_prev_card_panel', 600);
									//$('#simulation_next_card_loading').hide(200);
								}
						);
						//$('.panel_wrapper').scrollTo('#simulation_prev_card_panel', 600);
						//$('#simulation_next_card_loading').hide(200);
					}, 200);  // setTimeout
					
					// TODO: remove this Debug
					var profile = $('#simulation_debug_player_profile').val();
					$.get(window.baseurl + "general/ajax.php", { action: 'print_player_stats', profile_id: profile, header: true }, "html").done(
							function(stats) {
								//$('#debug > #player_stats').text(stats);
								$('.hidden_header_left_column').empty();
								$('.hidden_header_left_column').append(stats);
							}
					);
				}
		);
		
		//TODO: simulation_prev
		// Switch card order so that the sliding effect works and correct card is shown 
		// This have to be done because of proper scrolling effect from right to left
		var loading_panel = $('#simulation_loading_panel');
		var current_card_panel = $('#simulation_current_card_panel');
		$('#simulation_loading_panel').hide();
		$('#simulation_current_card_panel').hide();
		$('#simulation_loading_panel').remove();
		$('#simulation_current_card_panel').remove();
		$('#panel_mask_app').append(loading_panel);
		$('#panel_mask_app').append(current_card_panel);
		$('#simulation_prev_card_panel').show();
		$('#simulation_loading_panel').show();
		$('#simulation_current_card_panel').show();
		$('.panel_wrapper').scrollTo('#simulation_current_card_panel', 0);
	});
	
	// Back button action on previous card panel
	$(document).on( 'click', '.simulation_prev_prev', function(e) {
		//console.log("simulation_prev_prev");
		$('#simulation_next_card_loading').show();
		
		$.post(window.baseurl + "general/ajax.php", { action: 'previous_card' }, "json").done(
				function(cards) {
					
					// Check if session has expired and redirect
					if (cards.session_expired != undefined && cards.session_expired) {
						//console.log("session expired");
						window.showAddAccountPopupOnLeave = false;
						//var slug = getParameterByName('game_slug');
						var slug = getGameSlug();
						//window.location = "index.php?game_slug=" + slug;
						
						if (window.modRewrite) {
							window.location = window.baseurl + 'game/' + slug;
						}
						else {
							window.location = window.baseurl + "app/index.php?game_slug=" + slug;
						}
					}
					
					// TODO: Game ending here shouldn't be possible if it is then add this check in previous card too
					// Check if game ended and redirect
					if (cards.game_ended != undefined && cards.game_ended) {
						//console.log("game ended");
						window.showAddAccountPopupOnLeave = false;
						//var slug = getParameterByName('game_slug');
						var slug = getGameSlug();
						//window.location = "end.php?game_slug=" + slug;
						
						if (window.modRewrite) {
							window.location = window.baseurl + 'game/' + slug + '/end';
						}
						else {
							window.location = window.baseurl + "app/end.php?game_slug=" + slug;
						}
					}
					
					// So that current card doesn't update during slide
					window.setTimeout(function() {
						
						
						
						// Update the global current card variable
						window.globalCurrentCard = cards.current;
						window.globalBackEnabled = cards.back_enabled;
						
						// If next card doesn't exist
						if (cards.previous == undefined) {
							window.globalBackEnabled = false;
						}
						
					var card_name1 = '';
					if (cards.current.card_name) {
						card_name1 = cards.current.card_name;
					}
					else {
						card_name1 = cards.current.default_name;
					}
					var card_name2 = '';
					if (cards.previous != undefined) {
						if (cards.previous.card_name) {
							card_name2 = cards.previous.card_name;
						}
						else {
							card_name2 = cards.previous.default_name;
						}
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_name').html(card_name1); //.text(card_name1);
					$('#simulation_prev_card_panel > .panel_content > #simulation_card_name').html(card_name2); //text(card_name2);
					
					var image_src1 = '';
					if (cards.current.imageURL) {
						image_src1 = cards.current.imageURL;
					}
					var image_src2 = '';
					if (cards.previous != undefined && cards.previous.imageURL != undefined && cards.previous.imageURL != '') {
						image_src2 = cards.previous.imageURL;
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').attr('src', image_src1);
					$('#simulation_prev_card_panel > .panel_content > #simulation_card_image > img').attr('src', image_src2);
					if (image_src1 != '') {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').show();
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image').show();
					}
					else {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image > img').hide();
						$('#simulation_current_card_panel > .panel_content > #simulation_card_image').hide();
					}
					if (image_src2 != '') {
						$('#simulation_prev_card_panel > .panel_content > #simulation_card_image > img').show();
						$('#simulation_prev_card_panel > .panel_content > #simulation_card_image').show();
					}
					else {
						$('#simulation_prev_card_panel > .panel_content > #simulation_card_image > img').hide();
						$('#simulation_prev_card_panel > .panel_content > #simulation_card_image').hide();
					}
					
					var description1 = '';
					if (cards.current.description) {
						description1 = cards.current.description;
					}
					else {
						description1 = cards.current.default_description;
					}
					var description2 = '';
					if (cards.previous != undefined) {
						if (cards.previous.description) {
							description2 = cards.previous.description;
						}
						else {
							description2 = cards.previous.default_description;
						}
					}
					// Replace stat tags from description
					var profile = $('#simulation_debug_player_profile').val();
					$.get(window.baseurl + "general/ajax.php", { action: 'replace_stat_tags', profile_id: profile, text: description1 }, "json").done(
							function(result) {
								$('#simulation_current_card_panel > .panel_content > #simulation_card_description').html(result.modified_text); //.text(result.modified_text);
							}
					);
					/*$.get(window.baseurl + "general/ajax.php", { action: 'replace_stat_tags', profile_id: profile, text: description2 }, "json").done(
							function(result) {
								$('#simulation_prev_card_panel > .panel_content > #simulation_card_description').text(result.modified_text);
							}
					);*/
					//$('#simulation_current_card_panel > .panel_content > #simulation_card_description').text(description1);
					$('#simulation_prev_card_panel > .panel_content > #simulation_card_description').html(description2); //.text(description2);

					var expert_advice1 = '';
					if (cards.current.expert_advice) {
						expert_advice1 = cards.current.expert_advice;
					}
					else {
						expert_advice1 = cards.current.default_expert_advice;
					}
					var expert_advice2 = '';
					if (cards.previous != undefined) {
						if (cards.previous.expert_advice) {
							expert_advice2 = cards.previous.expert_advice;
						}
						else {
							expert_advice2 = cards.previous.default_expert_advice;
						}
					}
					$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice > .expert_advice').html(expert_advice1); //p.expert_advice').text(expert_advice1);
					if (!expert_advice1.length) {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice').hide();
					}
					else {
						$('#simulation_current_card_panel > .panel_content > #simulation_card_current_expert_advice').show();
					}
					$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice > .expert_advice').html(expert_advice2); //p.expert_advice').text(expert_advice2);
					if (!expert_advice2.length) {
						$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice').hide();
					}
					else {
						$('#simulation_prev_card_panel > .panel_content > #simulation_card_prev_expert_advice').show();
					}
					$('#simulation_current_card_panel > .panel_content > #current_card_id').val(cards.current.card_id);
					var previous_id = 0;
					if (cards.previous != undefined) {
						previous_id = cards.previous.card_id;
					}
					$('#simulation_prev_card_panel > .panel_content > #prev_card_id').val(previous_id);
					$('#simulation_card_current_choices').empty();
					$('#simulation_card_prev_choices').empty();
					
					if (cards.current.choices == undefined) {
						cards.current.choices = [];
					}
					
					$.get(window.baseurl + "general/ajax.php", { action: 'print_card_choices', choices: cards.current.choices, position: 'current' }, "html").done(
							function(choices) {
								
								// Check if session has expired and redirect
								if (choices.session_expired != undefined && choices.session_expired) {
									//console.log("session expired");
									window.showAddAccountPopupOnLeave = false;
									//var slug = getParameterByName('game_slug');
									var slug = getGameSlug();
									//window.location = "index.php?game_slug=" + slug;
									
									if (window.modRewrite) {
										window.location = window.baseurl + 'game/' + slug;
									}
									else {
										window.location = window.baseurl + "app/index.php?game_slug=" + slug;
									}
								}
								
								if (choices != undefined) {
									//$('#simulation_card_current_choices').append(choices);
									// Replace stat tags from choices
									var profile = $('#simulation_debug_player_profile').val();
									$.get(window.baseurl + "general/ajax.php", { action: 'replace_stat_tags', profile_id: profile, text: choices }, "json").done(
											function(result) {
												$('#simulation_card_current_choices').append(result.modified_text);
												// Check if there are no choices
												if (!$('#simulation_card_current_choices').children().length) {
													$('#simulation_current_card_panel > .panel_content > .selection_text').hide();
													$('#continue_simulation_current_button').show();
												}
												else {
													//$('#simulation_current_result_content').hide();
													$('#simulation_current_card_panel > .panel_content > .selection_text').show();
													$('#continue_simulation_current_button').hide();
												}
												$('#simulation_next_card_loading').hide(200);
												
												$('#simulation_loading_panel').hide();
												$('#simulation_current_card_panel').hide();
												var loading_panel = $('#simulation_loading_panel');
												var current_card_panel = $('#simulation_current_card_panel');
												$('#simulation_loading_panel').remove();
												$('#simulation_current_card_panel').remove();
												$('#panel_mask_app').append(current_card_panel);
												$('#panel_mask_app').append(loading_panel);
												$('#simulation_loading_panel').show();
												$('#simulation_current_card_panel').show();
												$('.panel_wrapper').scrollTo('#simulation_loading_panel', 0);
												// Enable back-buttons
												if (window.globalBackEnabled) {
													$('.simulation_prev').show();
												}
												else {
													$('.simulation_prev').hide();
												}
												$('.panel_wrapper').scrollTo('#simulation_current_card_panel', 800);
											}
									);
								}
								// Check if ending or sudden scenario
								/*if (!$('#simulation_card_current_choices').children().length) {
									$('#simulation_current_result_content').show();
									$('.selection_text').hide();
								}
								else {
									$('#simulation_current_result_content').hide();
									$('.selection_text').show();
								}*/
								/*
								// Check if there are no choices
								if (!$('#simulation_card_current_choices').children().length) {
									$('#simulation_current_card_panel > .panel_content > .selection_text').hide();
									$('#continue_simulation_current_button').show();
								}
								else {
									//$('#simulation_current_result_content').hide();
									$('#simulation_current_card_panel > .panel_content > .selection_text').show();
									$('#continue_simulation_current_button').hide();
								}
								$('#simulation_next_card_loading').hide(200);
								
								$('#simulation_loading_panel').hide();
								$('#simulation_current_card_panel').hide();
								var loading_panel = $('#simulation_loading_panel');
								var current_card_panel = $('#simulation_current_card_panel');
								$('#simulation_loading_panel').remove();
								$('#simulation_current_card_panel').remove();
								$('#panel_mask_app').append(current_card_panel);
								$('#panel_mask_app').append(loading_panel);
								$('#simulation_loading_panel').show();
								$('#simulation_current_card_panel').show();
								$('.panel_wrapper').scrollTo('#simulation_loading_panel', 0);
								//var previous_card_panel = $('#simulation_prev_card_panel');
								//var current_card_panel = $('#simulation_current_card_panel');
								//$('#simulation_loading_panel').hide();
								//$('#simulation_prev_card_panel').hide();
								//$('#simulation_loading_panel').remove();
								//$('#simulation_current_card_panel').remove();
								//$('#panel_mask_app').append(loading_panel);
								//$('#panel_mask_app').append(current_card_panel);
								
								// Enable back-buttons
								if (window.globalBackEnabled) {
									$('.simulation_prev').show();
								}
								else {
									$('.simulation_prev').hide();
								}
								$('.panel_wrapper').scrollTo('#simulation_current_card_panel', 800);
								//$('#simulation_next').click();
								*/
							}
					);
					if (cards.previous != undefined) {
						if (cards.previous.choices == undefined) {
							cards.previous.choices = [];
						}
						$.get(window.baseurl + "general/ajax.php", { action: 'print_card_choices', choices: cards.previous.choices, position: 'prev' }, "html").done(
								function(choices) {
									
									// Check if session has expired and redirect
									if (choices.session_expired != undefined && choices.session_expired) {
										//console.log("session expired");
										window.showAddAccountPopupOnLeave = false;
										//var slug = getParameterByName('game_slug');
										var slug = getGameSlug();
										//window.location = "index.php?game_slug=" + slug;
										
										if (window.modRewrite) {
											window.location = window.baseurl + 'game/' + slug;
										}
										else {
											window.location = window.baseurl + "app/index.php?game_slug=" + slug;
										}
									}
									
									if (choices != undefined) {
										$('#simulation_card_prev_choices').append(choices);
									}
									// Check if ending or sudden scenario
									/*if (!$('#simulation_card_prev_choices').children().length) {
										$('#simulation_prev_result_content').show();
										$('.selection_text').hide();
									}
									else {
										$('#simulation_prev_result_content').hide();
										$('.selection_text').show();
									}*/
									//$('#simulation_next_card_loading').hide(200);
									//$('#simulation_next').click();
								}
						);
					}
					
					
					}, 1000);  // setTimeout
					
					// TODO: remove this Debug
					var profile = $('#simulation_debug_player_profile').val();
					$.get(window.baseurl + "general/ajax.php", { action: 'print_player_stats', profile_id: profile, header: true }, "html").done(
							function(stats) {
								$('.hidden_header_left_column').empty();
								$('.hidden_header_left_column').append(stats);
								//$('#debug > #player_stats').text(stats);
								
							}
					);
				}
		);
		
		
		// TODO: switch card order so that the sliding effect works and correct card is shown
		// This have to be done because of proper scrolling effect from left to right
		
		//TODO: simulation_prev_prev
		var loading_panel = $('#simulation_loading_panel');
		var previous_card_panel = $('#simulation_prev_card_panel');
		//var current_card_panel
		$('#simulation_loading_panel').hide();
		$('#simulation_prev_card_panel').hide();
		$('#simulation_loading_panel').remove();
		$('#simulation_prev_card_panel').remove();
		$('#panel_mask_app').append(loading_panel);
		$('#panel_mask_app').append(previous_card_panel);
		$('#simulation_loading_panel').show();
		$('#simulation_prev_card_panel').show();
		$('#simulation_current_card_panel').show();
		$('.panel_wrapper').scrollTo('#simulation_prev_card_panel', 0);
		
		// This have to be done because of proper scrolling effect from right to left
		//$('.panel_wrapper').scrollTo('#simulation_loading_panel', 0);
		//$('#simulation_loading_panel').hide();
		//$('#simulation_prev_card_panel').show();
		//$('#simulation_current_card_panel').show();
		
	});
	
	$(document).on('click', '.expert_advice_link', function(e) {
		e.preventDefault();
		$(this).parent().parent().children('.expert_advice').toggle(200); //('p.expert_advice').toggle(200);
		//console.log("toggle");
	});
	
	// Back to simulation button clicked on end.php
	$(document).on('click', '#back_to_simulation_button', function() {

		$.post(window.baseurl + "general/ajax.php", { action: 'previous_card' }, "json").done(
				function(cards) {
					//var slug = getParameterByName('game_slug');
					var slug = getGameSlug();
					
					// Check if session has expired and redirect
					if (cards.session_expired != undefined && cards.session_expired) {
						//console.log("session expired");
						window.showAddAccountPopupOnLeave = false;
						//window.location = "index.php?game_slug=" + slug;
						
						if (window.modRewrite) {
							window.location = window.baseurl + 'game/' + slug;
						}
						else {
							window.location = window.baseurl + "app/index.php?game_slug=" + slug;
						}
					}
					
					//window.location = "simulation.php?game_slug=" + slug;
					
					if (window.modRewrite) {
						window.location = window.baseurl + 'game/' + slug + '/simulation';
					}
					else {
						window.location = window.baseurl + "app/simulation.php?game_slug=" + slug;
					}
				});
	});
	var continue_is_loading = false;
	
	$(document).on('click', '#continue_simulation_current_button, #continue_simulation_prev_button', function(e) {
		
		e.preventDefault();
		// Workaround for preventing multiple AJAX requests
		if (continue_is_loading) {
			return;
		}
		else {
			continue_is_loading = true;
		}
		var element_id = $(this).attr('id');
		
		$.post(window.baseurl + "general/ajax.php", { action: 'save_choice_and_give_result', choice_id: 0 }, "json").done(
				function(result) {
					
					// Check if session has expired and redirect
					if (result.session_expired != undefined && result.session_expired) {
						//console.log("session expired");
						window.showAddAccountPopupOnLeave = false;
						//var slug = getParameterByName('game_slug');
						var slug = getGameSlug();
						//window.location = "index.php?game_slug=" + slug;
						
						if (window.modRewrite) {
							window.location = window.baseurl + 'game/' + slug;
						}
						else {
							window.location = window.baseurl + "app/index.php?game_slug=" + slug;
						}
					}
					
					/*var result_message = '';
					if (result.result_text != undefined) {
						result_message = result.result_text;
					}
					else {
						result_message = result.default_text;
					}
					// So that current card doesn't update during slide
					//window.setTimeout(function() {	
					// TODO: remove this Debug
					var profile = $('#simulation_debug_player_profile').val();
					$.get("../general/ajax.php", { action: 'print_player_stats', profile_id: profile }, "html").done(
							function(stats) {
								$('#debug > #player_stats').text(stats);
								
							}
					);*/
					
					//$('#simulation_current_result_content > #simulation_result_description').text(result_message);
					//console.log($(this).attr('id'));
					//console.log(element_id);
					
					if (element_id == "continue_simulation_prev_button") {
						//console.log("continue_simulation_prev_button");
						$("#simulation_continue_prev").click();
						//$("#simulation_continue_current").click();
					}
					else {
						//console.log("continue_simulation_current_button");
						$("#simulation_continue_current").click();
					}
					continue_is_loading = false;
				//}, 1000);  // setTimeout
				}
		);
		/*if ($(this).attr('id') == "continue_simulation_current_button") {
			$("#simulation_continue_current").click();
		}
		else {
			$("#simulation_continue_prev").click();
		}*/
	});
	
	// Select simulation to open from app index.php
	$('#app_simulation_selection_open_simulation > .simulation_select').click( function() {
		// Check if current simulation is already selected
		if (!$(this).hasClass('simulation_selected')) {
			
			var selected_id = $(this).attr('id').split("select_simulation_")[1];
			
			// Remove previously selected
			$(this).parent().children('.simulation_select').each( function() {
				$(this).removeClass('simulation_selected');
				$(this).children('.select_simulation_delete, .select_simulation_image').hide(200);
			
			});
			// Mark clicked as selected
			$(this).addClass('simulation_selected');
			// Store simulation id to hidden input
			$('#app\\[open\\]\\[game_name\\]').val(selected_id);
			// Show delete simulation button
			$(this).children('.select_simulation_delete, .select_simulation_image').show(200);
		}
		else {
			$(this).removeClass('simulation_selected');
			$(this).children('.select_simulation_delete, .select_simulation_image').hide(200);
		}
	});
	
	// Select simulation to open from user settings
	$('#user_simulation_selection_open_simulation > .simulation_select').click( function() {
		// Check if current simulation is already selected
		if (!$(this).hasClass('simulation_selected')) {
			
			var selected_id = $(this).attr('id').split("user_select_simulation_")[1];
			
			// Remove previously selected
			$(this).parent().children('.simulation_select').each( function() {
				$(this).removeClass('simulation_selected');
				$(this).children('.select_simulation_delete, .select_simulation_image').hide(200);
			
			});
			// Mark clicked as selected
			$(this).addClass('simulation_selected');
			// Store simulation id to hidden input
			$('#user\\[settings\\]\\[open_game\\]\\[game_name\\]').val(selected_id);
			// Show delete simulation button
			$(this).children('.select_simulation_delete, .select_simulation_image').show(200);
		}
		else {
			$(this).removeClass('simulation_selected');
			$(this).children('.select_simulation_delete, .select_simulation_image').hide(200);
		}
	});
	// Open simulation from application index
	$('.app_select_simulation_start').click( function(e) {
		e.preventDefault();
		var selected_id = $(this).parent().attr('id').split("select_simulation_")[1];
		// Store simulation id to hidden input
		$('#app\\[open\\]\\[game_name\\]').val(selected_id);
		// Hide other selections
		$(this).parent().parent().children('.simulation_select').each( function() {
			var element_id = $(this).attr('id').split("select_simulation_")[1];
			if (element_id != $('#app\\[open\\]\\[game_name\\]').val()) {
				$(this).hide();
			}
			else {
				$(this).addClass('simulation_selected');
				$(this).children('.select_simulation_image').show(200);
				$(this).children('.app_select_simulation_start, .select_simulation_delete').hide(500);
			}
		});
		$('#user_select_simulation_loading').show();
		// Post form
		$('#app_open_game').click();
		return false;
	});
	
	$('#user_open_game, #user_select_simulation_loading').hide();
	
	// Open simulation from user settings
	$('.select_simulation_start').click( function(e) {
		e.preventDefault();
		var selected_id = $(this).parent().attr('id').split("user_select_simulation_")[1];
		// Store simulation id to hidden input
		$('#user\\[settings\\]\\[open_game\\]\\[game_name\\]').val(selected_id);
		// Hide other selections
		$(this).parent().parent().children('.simulation_select').each( function() {
			var element_id = $(this).attr('id').split("user_select_simulation_")[1];
			if (element_id != $('#user\\[settings\\]\\[open_game\\]\\[game_name\\]').val()) {
				$(this).hide();
			}
			else {
				$(this).addClass('simulation_selected');
				$(this).children('.select_simulation_image').show(200);
				$(this).children('.select_simulation_start, .select_simulation_delete').hide(500);
			}
		});
		$('#user_select_simulation_loading').show();
		// Post form
		$('#user_open_game').click();
		return false;
	});
	
	
	
	// Delete simulation from user settings
	$('.select_simulation_delete').click( function(e) {
		e.preventDefault();
		var selected_id = $(this).parent().attr('id').split("user_select_simulation_")[1];
		// Store simulation id to hidden input
		$('#user\\[settings\\]\\[open_game\\]\\[game_name\\]').val(selected_id);
		return false;
	});
	
	$('#delete_save_modal_yes_button').click( function(e) {
		var save_id = $('#user\\[settings\\]\\[open_game\\]\\[game_name\\]').val();
		$.post(window.baseurl + "general/ajax.php", { action: 'delete_profile', profile_id: save_id}, "json").done(
				function(result) {
					$('#user_select_simulation_' + result['deleted_profile']).remove();
					if (result.current_profile_deleted != undefined && result.current_profile_deleted) {
						var slug = getGameSlug();
						
						if (window.modRewrite) {
							window.location = window.baseurl + "game/" + slug;
						}
						else {
							window.location = window.baseurl + "app/index.php?game_slug=" + slug;
						}
					}
				}
		);
	});
	
	$('#delete_save_modal').jqm({
		trigger: '.select_simulation_delete',
		modal: true, /* FORCE FOCUS */
		onHide: function(h) { 
			h.o.remove(); // remove overlay
			h.w.fadeOut(500); // hide window
	      
		}, overlay: 50});
	
	$('#delete_profile_modal').jqm({
		trigger: '#delete_profile_button',
		modal: true, /* FORCE FOCUS */
		onHide: function(h) { 
			h.o.remove(); // remove overlay
			h.w.fadeOut(500); // hide window
	      
		}, overlay: 50});
	
	$('#delete_profile_button').click( function (e) {
		e.preventDefault();
	});
	
	// end
});